Rivet::WFinder Class Reference

Convenience finder of leptonically decaying Ws. More...

`#include <WFinder.hh>`

Inheritance diagram for Rivet::WFinder:

## Public Member Functions

const ParticleVector & | bosons () const
| Access to the found bosons (currently either 0 or 1)
const vector< Particle > & | constituentLeptons () const
const vector< Particle > & | constituentNeutrinos () const
const FinalState & | remainingFinalState () const
void | clear ()
| Clear the projection.
Constructors
| WFinder (const FinalState &inputfs, double etaMin, double etaMax, double pTmin, PdgId pid, double minmass, double maxmass, double missingET, double dRmax, bool clusterPhotons=true, bool trackPhotons=false, double masstarget=80.4, bool useTransverseMass=false)
| WFinder (const FinalState &inputfs, const std::vector< std::pair< double, double > > &etaRanges, double pTmin, PdgId pid, double minmass, const double maxmass, double missingET, double dRmax, bool clusterPhotons=true, bool trackPhotons=false, double masstarget=80.4, bool useTransverseMass=false)
| WFinder (double, double, double, PdgId, double, double, double, double, bool clusterPhotons=true, bool trackPhotons=false, double masstarget=80.4, bool useTransverseMass=false)
| WFinder (const std::vector< std::pair< double, double > > &, double, PdgId, double, double, double, double, bool clusterPhotons=true, bool trackPhotons=false, double masstarget=80.4, bool useTransverseMass=false)
virtual const Projection * | clone () const
| Clone on the heap.
Public Member Functions inherited from Rivet::FinalState
virtual const ParticleVector & | particles () const
| Get the final-state particles.
template<typename F >
const ParticleVector & | particles (F sorter) const
| Get the final-state particles, ordered by supplied sorting function object.
const ParticleVector & | particlesByPt () const
| Get the final-state particles, ordered by decreasing .
const ParticleVector & | particlesByP () const
| Get the final-state particles, ordered by decreasing .
const ParticleVector & | particlesByE () const
| Get the final-state particles, ordered by decreasing .
const ParticleVector & | particlesByEt () const
| Get the final-state particles, ordered by decreasing .
const ParticleVector & | particlesByEta () const
| Get the final-state particles, ordered by increasing .
const ParticleVector & | particlesByModEta () const
| Get the final-state particles, ordered by increasing .
const ParticleVector & | particlesByRapidity () const
| Get the final-state particles, ordered by increasing .
const ParticleVector & | particlesByModRapidity () const
| Get the final-state particles, ordered by increasing .
virtual size_t | size () const
| Access the projected final-state particles.
virtual bool | empty () const
| Is this final state empty?
virtual bool | isEmpty () const
virtual double | ptMin () const
| Minimum- requirement.
const collection_type & | entities () const
| Template-usable interface common to JetAlg.
| FinalState (double mineta=-MAXRAPIDITY, double maxeta=MAXRAPIDITY, double minpt=0.0 *GeV)
| FinalState (const vector< pair< double, double > > &etaRanges, double minpt=0.0 *GeV)
Public Member Functions inherited from Rivet::Projection
bool | before (const Projection &p) const
virtual const std::set< PdgIdPair > | beamPairs () const
virtual std::string | name () const
| Get the name of the projection.
Projection & | addPdgIdPair (PdgId beam1, PdgId beam2)
| Add a colliding beam pair.
Log & | getLog () const
| Get a Log object based on the getName() property of the calling projection object.
void | setName (const std::string &name)
| Used by derived classes to set their name.
| Projection ()
| The default constructor.
virtual | ~Projection ()
| The destructor.
Public Member Functions inherited from Rivet::ProjectionApplier
| ProjectionApplier ()
| Constructor.
std::set< ConstProjectionPtr > | getProjections () const
| Get the contained projections, including recursion.
template<typename PROJ >
const PROJ & | getProjection (const std::string &name) const
| Get the named projection, specifying return type via a template argument.
const Projection & | getProjection (const std::string &name) const
template<typename PROJ >
const PROJ & | applyProjection (const Event &evt, const PROJ &proj) const
| Apply the supplied projection on event.
template<typename PROJ >
const PROJ & | applyProjection (const Event &evt, const Projection &proj) const
| Apply the supplied projection on event.
template<typename PROJ >
const PROJ & | applyProjection (const Event &evt, const std::string &name) const
| Apply the named projection on event.

## Protected Member Functions

void | project (const Event &e)
| Apply the projection on the supplied event. More...
int | compare (const Projection &p) const
| Compare projections.
Protected Member Functions inherited from Rivet::FinalState
bool | accept (const Particle &p) const
| Decide if a particle is to be accepted or not.
Protected Member Functions inherited from Rivet::Projection
Cmp< Projection > | mkNamedPCmp (const Projection &otherparent, const std::string &pname) const
Cmp< Projection > | mkPCmp (const Projection &otherparent, const std::string &pname) const
Protected Member Functions inherited from Rivet::ProjectionApplier
Log & | getLog () const
ProjectionHandler & | getProjHandler () const
| Get a reference to the ProjectionHandler for this thread.
template<typename PROJ >
const PROJ & | addProjection (const PROJ &proj, const std::string &name)

## Additional Inherited Members

Public Types inherited from Rivet::FinalState
typedef Particle | entity_type
typedef ParticleVector | collection_type

## Detailed Description

Convenience finder of leptonically decaying Ws.

Chain together different projections as convenience for finding W's from two leptons in the final state, including photon clustering.

## Constructor & Destructor Documentation

## WFinder() [1/4]

Rivet::WFinder::WFinder | ( | const FinalState & | inputfs,
|  | double | etaMin,
|  | double | etaMax,
|  | double | pTmin,
|  | PdgId | pid,
|  | double | minmass,
|  | double | maxmass,
|  | double | missingET,
|  | double | dRmax,
|  | bool | clusterPhotons = `true`,
|  | bool | trackPhotons = `false`,
|  | double | masstarget = `80.4`,
|  | bool | useTransverseMass = `false`
| ) |  |

Constructor taking single eta/pT bounds

Parameters

  inputfs | Input final state
  etaMin,etaMax,pTmin | charged lepton cuts
  pid | type of the charged lepton
  minmass,maxmass | (transverse) mass window
  missingET | minimal amount of missing ET (neutrinos) required
  dRmax | maximum dR of photons around charged lepton to take into account for W reconstruction (only relevant if one of the following are true)
  clusterPhotons | whether such photons are supposed to be clustered to the lepton object and thus W mom
  trackPhotons | whether such photons should be added to _theParticles (cf. _trackPhotons)
  useTransverseMass | whether mass window should be applied using mT

Referenced by clone().

## WFinder() [2/4]

Rivet::WFinder::WFinder | ( | const FinalState & | inputfs,
|  | const std::vector< std::pair< double, double > > & | etaRanges,
|  | double | pTmin,
|  | PdgId | pid,
|  | double | minmass,
|  | const double | maxmass,
|  | double | missingET,
|  | double | dRmax,
|  | bool | clusterPhotons = `true`,
|  | bool | trackPhotons = `false`,
|  | double | masstarget = `80.4`,
|  | bool | useTransverseMass = `false`
| ) |  |

Constructor taking multiple eta/pT bounds

Parameters

  inputfs | Input final state
  etaRanges,pTmin | charged lepton cuts
  pid | type of the charged lepton
  minmass,maxmass | (transverse) mass window
  missingET | minimal amount of missing ET (neutrinos) required
  dRmax | maximum dR of photons around charged lepton to take into account for W reconstruction (only relevant if one of the following are true)
  clusterPhotons | whether such photons are supposed to be clustered to the lepton object and thus W mom
  trackPhotons | whether such photons should be added to _theParticles (cf. _trackPhotons)
  useTransverseMass | whether mass window should be applied using mT

## WFinder() [3/4]

Rivet::WFinder::WFinder | ( | double | etaMin,
|  | double | etaMax,
|  | double | pTmin,
|  | PdgId | pid,
|  | double | minmass,
|  | double | maxmass,
|  | double | missingET,
|  | double | dRmax,
|  | bool | clusterPhotons = `true`,
|  | bool | trackPhotons = `false`,
|  | double | masstarget = `80.4`,
|  | bool | useTransverseMass = `false`
| ) |  |

Deprecated:
  Constructors without inputfs – only for backwards compatibility

## WFinder() [4/4]

Rivet::WFinder::WFinder | ( | const std::vector< std::pair< double, double > > & | etaRanges,
|  | double | pTmin,
|  | PdgId | pid,
|  | double | minmass,
|  | double | maxmass,
|  | double | missingET,
|  | double | dRmax,
|  | bool | clusterPhotons = `true`,
|  | bool | trackPhotons = `false`,
|  | double | masstarget = `80.4`,
|  | bool | useTransverseMass = `false`
| ) |  |

Deprecated:
  Constructors without inputfs – only for backwards compatibility

References Rivet::IdentifiedFinalState::acceptIdPair(), Rivet::IdentifiedFinalState::acceptNeutrinos(), Rivet::ProjectionApplier::addProjection(), Rivet::VetoedFinalState::addVetoOnThisFinalState(), and Rivet::Projection::setName().

## Member Function Documentation

## constituentLeptons()

const vector<Particle>& Rivet::WFinder::constituentLeptons | ( |  | ) | const

inline

Access to the W constituent clustered leptons (currently either of size 0 if no boson was found or 1 if one boson was found)

## constituentNeutrinos()

const vector<Particle>& Rivet::WFinder::constituentNeutrinos | ( |  | ) | const

inline

Access to the W constituent neutrinos (currently either of size 0 if no boson was found or 1 if one boson was found)

References compare(), project(), and remainingFinalState().

## project()

void Rivet::WFinder::project | ( | const Event & | e | ) |

protected virtual

Apply the projection on the supplied event.

Todo:
  Restrict missing momentum eta range? Use vectorET()?

Reimplemented from Rivet::FinalState.

References Rivet::InvMassFinalState::calc(), clear(), Rivet::Particle::momentum(), Rivet::InvMassFinalState::particlePairs(), Rivet::Particle::pdgId(), and Rivet::InvMassFinalState::useTransverseMass().

Referenced by constituentNeutrinos().

## remainingFinalState()

const FinalState & Rivet::WFinder::remainingFinalState | ( |  | ) | const

Access to the remaining particles, after the W and clustered photons have been removed from the full final state (e.g. for running a jet finder on it)

Referenced by constituentNeutrinos().

The documentation for this class was generated from the following files:

- include/Rivet/Projections/WFinder.hh
- src/Projections/WFinder.cc